/*
 For more information, please see: http://software.sci.utah.edu
 
 The MIT License
 
 Copyright (c) 2009 Scientific Computing and Imaging Institute,
 University of Utah.
 
 
 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the "Software"),
 to deal in the Software without restriction, including without limitation
 the rights to use, copy, modify, merge, publish, distribute, sublicense,
 and/or sell copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following conditions:
 
 The above copyright notice and this permission notice shall be included
 in all copies or substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 DEALINGS IN THE SOFTWARE.
 */

#ifndef INTERFACE_APPLICATION_PROVENANCEDOCKWIDGET_H
#define INTERFACE_APPLICATION_PROVENANCEDOCKWIDGET_H

// Qt includes
#include <QAbstractItemModel>

// QtUtils includes
#include <QtUtils/Widgets/QtCustomDockWidget.h>

namespace Seg3D
{
	
class ProvenanceDockWidgetPrivate;

class ProvenanceDockWidget : public QtUtils::QtCustomDockWidget
{
	Q_OBJECT
	
public:
	ProvenanceDockWidget( QWidget *parent = 0 );
	virtual ~ProvenanceDockWidget();

private Q_SLOTS:
	// UPDATE_CURRENT_PROVENANCE_STEP:
	// Update the detailed information when the current selected step has changed.
	void handle_current_step_changed( const QModelIndex& index );

	// DISPATCH_RECREATE_PROVENANCE:
	// Dispatch an ActionRecreateLayer if the current selected row has a valid provenance ID of interest.
	void dispatch_recreate_provenance();

	// REFRESH_PROVENANCE_TRAIL:
	// Request the up-to-date provenance trail of the current active layer.
	void refresh_provenance_trail();

private:
	friend class ProvenanceDockWidgetPrivate;
	ProvenanceDockWidgetPrivate* private_;
};
	
} // end namespace Seg3D

#endif 
